var events = require("sdk/system/events");
var chrome = require("chrome");
var tabIdToUrlMap = {};


var LOAD_INITIAL_DOCUMENT_URI = 524288;


var tabs = require("sdk/tabs");

tabs.on('close', function(tab) {
    delete tabIdToUrlMap[tab.id];
});

function openingListener(event) {
    var channel = event.subject.QueryInterface(chrome.Ci.nsIHttpChannel);
    var isOriginatingURL = channel["loadFlags"] & LOAD_INITIAL_DOCUMENT_URI;
    
    if(isOriginatingURL > 0) {
        var tabId = tabs.activeTab.id;
        var url = channel["name"];
        tabIdToUrlMap[tabId] = url;
    }
}
events.on("http-on-opening-request", openingListener);


function modifyingListener(event) {
    var channel = event.subject.QueryInterface(chrome.Ci.nsIHttpChannel);
    var url = tabIdToUrlMap[tabs.activeTab.id];
    channel.setRequestHeader("X-CW-PageURL", url, false);
}
events.on("http-on-modify-request", modifyingListener);